/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2021-2021. All rights reserved.
 */

package com.huawei.agc.flutter.appmessaging.handlers;

import android.app.Activity;

import com.huawei.agc.flutter.appmessaging.utils.Utils;
import com.huawei.agconnect.AGConnectInstance;
import com.huawei.agconnect.appmessaging.AGConnectAppMessaging;

import io.flutter.plugin.common.EventChannel.EventSink;
import io.flutter.plugin.common.EventChannel.StreamHandler;

public class AGCAppMessagingOnMessageDisplayStreamHandler implements StreamHandler {

    public AGCAppMessagingOnMessageDisplayStreamHandler(final Activity activity) {
        if (AGConnectInstance.getInstance() == null) {
            AGConnectInstance.initialize(activity.getApplicationContext());
        }
    }

    @Override
    public void onListen(final Object arguments, final EventSink eventSink) {
        AGConnectAppMessaging.getInstance().addOnDisplayListener(appMessage -> {
            eventSink.success(Utils.fromAppMessageToMap(appMessage));
        });
    }

    @Override
    public void onCancel(final Object arguments) {
    }
}
