// Copyright (c) Huawei Technologies Co., Ltd. 2021-2021. All rights reserved.

part of agconnect_appmessaging;

class AGCAppMessagingException implements Exception {
  final String code;
  final String message;

  const AGCAppMessagingException._({
    required this.code,
    required this.message,
  });

  factory AGCAppMessagingException._from(dynamic e) {
    if (e is AGCAppMessagingException) {
      return e;
    } else {
      if (e is PlatformException) {
        return AGCAppMessagingException._(
          code: e.code,
          message: e.message ?? 'Something went wrong.',
        );
      } else {
        return AGCAppMessagingException._(
          code: 'UNKNOWN',
          message: e is String ? e : 'Something went wrong.',
        );
      }
    }
  }

  @override
  String toString() {
    return '$AGCAppMessagingException('
        'code: $code, '
        'message: $message)';
  }
}
